// Vertex Shader
// shader version
#version 400

// input matrix transforms (3D) passed in 
// from our program
layout ( std140, set = 0, binding = 0 ) uniform buffer 
{
  mat4 projection_matrix;
  mat4 view_matrix;
  mat4 model_matrix;
} UBO;

// input a position and a colour
layout( location = 0 ) in vec4 pos;
layout( location = 1 ) in vec3 color;

// output a color
layout( location = 0 ) out struct vertex_out 
{
  vec4 vColor;
} OUT;


// shader entry point
void main() 
{	
  // combine the matrices
  mat4 modelView = UBO.model_matrix * UBO.view_matrix;

  // transform position by matrices
  gl_Position = pos * ( modelView * UBO.projection_matrix );

  // pass input colour to the next stage
  OUT.vColor = vec4(color, 1.0);
  // Or a fixed test color (RED)
  // OUT.vColor = vec4( 1.0, 0.0, 0.0, 1 );

}// End main(..)